%==========================================================================
function [X, P]  = fcn_ls(A,B)
% Solves the linear equation AX=B using least-square batch
% Input: A-system input, B-system output
% Output: X-the system parameters, P-parameter covariance 
% source: [p.~4]{Cirrincione2010}
%
[m , n] = size(A);
X=(A'*A)\A'*B; %modell parameter
e=B-A*X; %modell error
squad=1/(m-n)*(e'*e); %estimated measurement variance
P=squad* ((A'*A)\eye(n)); %parameter covariance matrix
end
%==========================================================================
