%source: [Feng2007]

function [R_new, q_new, v_new, X_rtiv] = fcn_rtiv(R_old, q_old, v_old, Z, IV, lambda)

R_new = lambda * R_old + (IV' * Z);

p_tilde = R_new * q_old;
q_tilde = R_new' * p_tilde; %power method
smax = norm(q_tilde); %square of the largest singular value
q_new = q_tilde / smax; %normalization

u_tilde = R_new * v_old;
v_tilde = R_new' * u_tilde; %power method
smin = norm(v_tilde); %square of the smallest singular value
sh = 0.5*smax + smin; %shift parameter
v_hat = sh*v_old - v_tilde; %shift operation
v_new = v_hat / norm(v_hat); %normalization

X_rtiv = -v_new(1:end-1)/v_new(end);

end