function Versuchsplan = fcn_runEstimators(varargin)
if nargin == 0%no input argument
% setup Versuchsplan
In.wiederholungen = 1000; % Anzahl der Wiederholungen je Versuch
In.m = {...Anzahl der Samples
     %1000;...
     %2000;...
     10000;...
     };
In.InputTyp = {...Wahl der Form des Inputs
            %'sinus';...
            'modulierterSinus'...
            %'constant';...
            %'sawtooth';...
            %'square';...
            %'exp_up';...
            %'exp_down';...
            };
In.inputTuning = {...Wahl des Tuningparameters
                 %[1e-3 ,1e-3 ,1e-3];...eine Periode pro 1000 samples
                  [6e-3 ,12e-3 ,14e-3];...
                 %[1e-4 ,1e-4 ,1e-4];...
                 };
In.windup = {...Jede Spalte ist fr einen Eingangskanal
          ...Oberer Wert Windup Anfang unterer Windup Ende
          ...Deaktivieren je Eingangskanal mit [1;1]
          [1 1 1;...
           1 1 1];...
          %[1 100 1;...
          % 1 311 1]...
           };
In.X_true = {...
          %[1;...
          % 2;...
          % 3];...konstante Parameter
            ...    
          [1 2 5000; ...Parameter 1 auf 4 bei sample 330
           2 2 1; ...
           3 3 1 ];...
           };
In.NoiseSigma2={...Einstellung des Messrauschens sigma^2 [Eingang1, Eingang2, ....] 
             [0.1 .2 .4 1];...RGTLS case
             [0 0 0 1];...RLS case
             %[1 1 1 1];...RTLS case
             %[.3 .1 .2 .7]...
             };
In.NoiseTyp = {...Wahl des Verluafes von Noise
            'constant';...
            %'sinus';...
            %'markov'...
            };        
In.noiseTuning = {...Periodenlnge oder sigma^2 (Markov) fr Noisemodulation: noiseTuning = {[1e-4 ,2*1e-4 ,2.5*1e-4]};
               [5e-5 ,5e-5 ,5e-5 ,5e-5];...
               %[1e-6 ,2*1e-6 ,2.5*1e-6 ,.5*1e-6];...
               };
Versuchsplan = fcn_runVersuchsplan(In);
%save('Versuchsplan.mat', 'Versuchsplan', '-v7.3');
else
Versuchsplan = varargin{1};
wdh = varargin{2};
fcn_plots(Versuchsplan, wdh);  
end
end % of function
%
function Versuchsplan = fcn_runVersuchsplan(In)
%
wiederholungen = In.wiederholungen;
%
% Vollfaktoriellen Versuchsplan erstellen
Versuchsplan = fcn_versuchsplan_erstellen(In);
%
%-Waitbar----------------------------------------------------------
waitbarIter = 0;
overallWaitbar = numel(Versuchsplan)*wiederholungen;
handleWaitbar = waitbar(0, sprintf('file %d of %d files finished',...
   waitbarIter, overallWaitbar));
waitbar(0 , handleWaitbar);
%------------------------------------------------------------------
for i=1:size(Versuchsplan, 1)  %Versuche zeilenweise abarbeiten
    for k = 1 : wiederholungen      
        singleSimData = fcn_simulationsdaten_erstellen(Versuchsplan{i});
        SimData.Single.(['wdh' int2str(k)]) = singleSimData.Single;
        SimData.Repeat = singleSimData.Repeat;
        %call estimators---------------------------------------------------
        Result_RLS = fcn_callRLS (singleSimData);
        Result.RLS.Single.(['wdh' int2str(k)]) = Result_RLS;
        %
        Result_RTIV = fcn_callRTIV (singleSimData);
        Result.RTIV.Single.(['wdh' int2str(k)]) = Result_RTIV;
        %
        Result_RGTLS = fcn_callRGTLS (singleSimData);
        Result.RGTLS.Single.(['wdh' int2str(k)]) = Result_RGTLS;
        %------------------------------------------------------------------
        %-Waitbar----------------------------------------------------------
        waitbarIter = waitbarIter + 1;
        waitbar(waitbarIter / overallWaitbar, handleWaitbar, ...
        sprintf('file %d of %d files finished', waitbarIter, overallWaitbar)); 
        %------------------------------------------------------------------
    end 
        Versuchsplan{i}.SimData = SimData;
        %        
        Averaged_RLS = fcn_avgError (Result.RLS.Single);
        Result.RLS.Averaged = Averaged_RLS;
        %
        Averaged_RTIV = fcn_avgError (Result.RTIV.Single);
        Result.RTIV.Averaged = Averaged_RTIV;        
        %
        Averaged_RGTLS = fcn_avgError (Result.RGTLS.Single);
        Result.RGTLS.Averaged = Averaged_RGTLS;
        %
        Versuchsplan{i}.Result = Result;
end
delete(handleWaitbar); %close Waitbar  
%
end %of Main function------------------------------------------------------
%
function fcn_plots(Versuchsplan, wdh)
set(0, 'DefaulttextInterpreter', 'none'); %underscores are displayed
set(0,'defaultlinelinewidth',1.5); %thicker lines as default
set(0,'DefaultFigureWindowStyle','docked'); %all figures are docked
    cc = [0   0   1;...%a colormap with (i) entries
          1   0   0;...
          0   1   0;...
          0   0.5 0;...
          0   1   1;...
          0   0   0];% last is color for true values 
% figure mean_e_SEVN mean_e_SE
s = fieldnames(Versuchsplan{1}.Result); %estimator names
n = size(Versuchsplan{1}.SimData.Repeat.X_true,2); %number of parameters
q = size(Versuchsplan{1}.SimData.Single.('wdh1').NoiseSigma2, 2); %number of input/output channels
for j = 1 : numel(Versuchsplan)
    figure
    subplot(1,3,1)
    hold on
    for i=1:numel(s)
       plot(Versuchsplan{j}.Result.(s{i}).Averaged.mean_e_SEVN, '.', 'Color', cc(i,:)) 
    end
    title(['Versuch' int2str(j)]);
    legend(s);
    xlabel('samples');
    ylabel('mean_e_SEVN');
    %
    subplot(1,3,2)
    hold on
    for i=1:numel(s)
       plot(Versuchsplan{j}.Result.(s{i}).Averaged.mean_e_SE, '.', 'Color', cc(i,:)) 
    end
    title(['Versuch' int2str(j)]);
    legend(s);
    xlabel('samples');
    ylabel('mean_e_SE');
    %
    subplot(1,3,3)
    hold on
    for i=1:numel(s)
       plot(Versuchsplan{j}.Result.(s{i}).Averaged.mean_r_SE, '.', 'Color', cc(i,:)) 
    end
    title(['Versuch' int2str(j)]);
    legend(s);
    xlabel('samples');
    ylabel('mean_r_SE');
end
% individual file results with 'wdh#'
% figure NoiseSigma2_true NoiseSigma2_hat
for j = 1 : numel(Versuchsplan)
    figure
    for i = 1:q %for each parameter
        subplot(2,2,i)
        hold on
        plot(Versuchsplan{j}.Result.RGTLS.Single.(wdh).NoiseSigma2(:,i), '.', 'Color', cc(1,:));
        plot(Versuchsplan{j}.SimData.Single.(wdh).NoiseSigma2(:,i), 'Color', cc(end,:));
        %
        title(sprintf('Versuch %d \n %s', j, wdh))
        legend(['BLRH';'true']);
        xlabel('samples');
        ylabel(sprintf('noiseVar channel %d', i));
    end
end
%
% figure X_hat and X_true
for j = 1 : numel(Versuchsplan)
    figure
    for i=1:n %for each parameter
        subplot(2,2,i)
        hold on
        for k=1:numel(s) %number of parameters
            plot(Versuchsplan{j}.Result.(s{k}).Single.(wdh).X_hat(:,i), '.', 'Color', cc(k,:));
        end
        plot(Versuchsplan{j}.SimData.Repeat.X_true(:,i), 'Color', cc(end,:));
        %
        title(sprintf('Versuch %d \n %s', j, wdh))
        legendnames = s; legendnames{k+1}='true';
        legend(legendnames);
        xlabel('samples');
        ylabel('X');
    end
end
%
%text Dateien schreiben
%BLRH NoiseSigma2 estimation
for j = 1 : numel(Versuchsplan)
    str = 'NoiseSigma2_Versuch';
    NoiseSigma2_true = Versuchsplan{j}.SimData.Single.(wdh).NoiseSigma2;
    NoiseSigma2_hat = Versuchsplan{j}.Result.RGTLS.Single.(wdh).NoiseSigma2;
    m = size(NoiseSigma2_true,1);
    fid = fopen(sprintf('%s%d_%s%s', str, j, wdh,'.txt'),'w');
    fprintf(fid,'NoiseSigma2_true1\t NoiseSigma2_true2\t NoiseSigma2_true3\t NoiseSigma2_true4\t NoiseSigma2_hat1\t NoiseSigma2_hat2\t NoiseSigma2_hat3\t NoiseSigma2_hat4\t time\n');
    fprintf(fid,'%g\t %g\t %g\t %g\t %g\t %g\t %g\t %g\t %g\n', [NoiseSigma2_true, NoiseSigma2_hat, (1:m)']');
    fclose(fid);
end
%mean errors
mean_e_SEVN_Estimators = zeros(m , numel(s));
for j = 1 : numel(Versuchsplan)
    for i=1:numel(s)
        mean_e_SEVN_Estimators(:,i) = Versuchsplan{j}.Result.(s{i}).Averaged.mean_e_SEVN;
    end     
    str = 'meanErrors_Versuch';
    estStrg = strcat('mean_e_SEVN_',s,'\t');
    sep = '%g\t';
    for i=1:numel(s)-1
        sep = [sep , '%g\t'];
    end
    sep = [sep , '%g\n']; %last column
    fid = fopen(sprintf('%s%d%s', str, j, '.txt'),'w');
    for i=1:numel(s)
    fprintf(fid,estStrg{i}); %write estimator names   
    end
    fprintf(fid,'time\n'); %last column  
    fprintf(fid, sep, [mean_e_SEVN_Estimators, (1:m)']'); %last column 
    fclose(fid);
end
%A_true B_true
A_true = Versuchsplan{1}.SimData.Repeat.A_true;
B_true = Versuchsplan{1}.SimData.Repeat.B_true;
fid = fopen('Z_true.txt' ,'w');
fprintf(fid,'A_true1\t A_true2\t A_true3\t B_true\t time\n');
fprintf(fid,'%g\t %g\t %g\t %g\t %g\n',...
    [A_true, B_true, (1:m)']');
fclose(fid);
end %of function-----------------------------------------------------------
%
function Averaged = fcn_avgError (Result)
%
s =  fieldnames(Result);
j = numel(s); %Anzahl Widerholungen
m = size(Result.(s{1}).e_SEVN , 1);
e_SEVN = zeros(m , j);
e_SE = zeros(m , j);
r_SE = zeros(m , j);
%
for j=1:numel(s) %je Spalte eine Simulation
    e_SEVN(:,j) = Result.(s{j}).e_SEVN;
    e_SE(:,j) = Result.(s{j}).e_SE;
    r_SE(:,j) = Result.(s{j}).r_SE;
end
mean_e_SEVN = mean(e_SEVN , 2);
mean_e_SE = mean(e_SE , 2);
mean_r_SE = mean(r_SE , 2);
%
Averaged.mean_e_SEVN = mean_e_SEVN;
Averaged.mean_e_SE = mean_e_SE;
Averaged.mean_r_SE = mean_r_SE;
%
end %of function-----------------------------------------------------------
%
function Result = fcn_callRLS (singleSimData)
%
A_error = singleSimData.Single.A_error;
A_true = singleSimData.Repeat.A_true;
A_mess = A_true + A_error;
B_error = singleSimData.Single.B_error;
B_true = singleSimData.Repeat.B_true;
B_mess = B_true + B_error;
X_true = singleSimData.Repeat.X_true;
%
[m , n] = size(A_mess);
%Filter Setup--------------------------------------------------------------
init = 30;
lambda = 0.998; %single forgetting
%-preallocation------------------------------------------------------------
X_hat_save = zeros(m,n);
B_hat_save = zeros(m,1);
e_SEVN_save = zeros(m,1);
e_SE_save = zeros(m,1);
r_SE_save = zeros(m,1);
%--------------------------------------------------------------------------
for i = init : m
    if i < init;
    % do nothing    
    elseif i == init
    [X_hat, P]  = fcn_ls(A_mess(1:i,:) , B_mess(1:i,:));        
    else    
    [X_hat, P]=fcn_rls(A_mess(i,:), B_mess(i), X_hat, P, lambda);
    B_hat = A_mess(i,:) * X_hat;
    e_SEVN = norm(X_true(i,:)' - X_hat)^2;
    e_SE = (B_mess(i) - B_hat)^2;
    r_SE = (B_true(i) - A_true(i,:) * X_hat)^2;
    % Ergebnisse speichern    
    X_hat_save(i,:) = X_hat';
    B_hat_save(i) = B_hat;
    e_SEVN_save(i) = e_SEVN;
    e_SE_save(i) = e_SE;
    r_SE_save(i) = r_SE;
    end
end
Result.X_hat = X_hat_save;
Result.B_hat = B_hat_save;
Result.e_SEVN = e_SEVN_save;
Result.e_SE = e_SE_save;
Result.r_SE = r_SE_save;
%
end %of function-----------------------------------------------------------
%
function Result = fcn_callRTIV (singleSimData)
%
A_error = singleSimData.Single.A_error;
A_true = singleSimData.Repeat.A_true;
A_mess = A_true + A_error;
B_error = singleSimData.Single.B_error;
B_true = singleSimData.Repeat.B_true;
B_mess = B_true + B_error;
X_true = singleSimData.Repeat.X_true;
%
[m , n] = size(A_mess);
%Filter Setup--------------------------------------------------------------
init = 30;
lambda = 0.998; %single forgetting
IVdelay = 4; %delay of instrumental variables
%-preallocation------------------------------------------------------------
X_hat_save = zeros(m,n);
B_hat_save = zeros(m,1);
e_SEVN_save = zeros(m,1);
e_SE_save = zeros(m,1);
r_SE_save = zeros(m,1);
%--------------------------------------------------------------------------
for i = init : m
    if i < init;
    % do nothing    
    elseif i == init
    R = [A_mess(1:i,:) , B_mess(1:i,:)]'*[A_mess(1:i,:) , B_mess(1:i,:)];
    q = R * ones(n+1,1);
    v = R * ones(n+1,1);   
    % mehr Instrumente--------------
    % R = zeros(6,4);
    % q = ones(n+1,1);
    % v = ones(n+1,1);
    %-------------------------------
    else
    Z = [A_mess(i,:), B_mess(i)];
    IV = [A_mess(i-IVdelay,:), B_mess(i-IVdelay)];
    % mehr Instrumente--------------
    % IV = [A_mess(i-IVdelay+1,:) , A_mess(i-IVdelay,:)];
    % ------------------------------
    [R, q, v, X_hat] = fcn_rtiv(R, q, v, Z, IV, lambda);    
    %
    B_hat = A_mess(i,:) * X_hat;
    e_SEVN = norm(X_true(i,:)' - X_hat)^2;
    e_SE = (B_mess(i) - B_hat)^2;
    r_SE = (B_true(i) - A_true(i,:) * X_hat)^2;
    % Ergebnisse speichern    
    X_hat_save(i,:) = X_hat';
    B_hat_save(i) = B_hat;
    e_SEVN_save(i) = e_SEVN;
    e_SE_save(i) = e_SE;
    r_SE_save(i) = r_SE;
    end
end
Result.X_hat = X_hat_save;
Result.B_hat = B_hat_save;
Result.e_SEVN = e_SEVN_save;
Result.e_SE = e_SE_save;
Result.r_SE = r_SE_save;
%
end %of function-----------------------------------------------------------
%
function Result = fcn_callRGTLS (singleSimData)
%
A_error = singleSimData.Single.A_error;
A_true = singleSimData.Repeat.A_true;
A_mess = A_true + A_error;
B_error = singleSimData.Single.B_error;
B_true = singleSimData.Repeat.B_true;
B_mess = B_true + B_error;
Z_mess = [A_mess B_mess];
X_true = singleSimData.Repeat.X_true;
%
[m , n] = size(A_mess);
q = n + 1;
%Filter Setup--------------------------------------------------------------
errCov = 0.3*eye(q); %init as TLS
lambda = 0.998; % single forgetting
%PKS Filter
leftWindow = 30;
rightWindow = 30;
% FilterLength = leftWindow + rightWindow + 1;
% R = 1-1/FilterLength; %1-1/n mit n Fensterlnge
R = 0.9;
Order = 4; %Polynom Koefficients
shiftIncrement = 1;
[calA, u, uSmooth] = fcn_PKSFilterInit(Order, shiftIncrement, leftWindow,...
    rightWindow);
PKS_X = zeros(Order+1,1,q);
PKS_P = zeros(Order+1, Order+1, q);
for k = 1:q
    PKS_P(:,:,k) = 100*eye(Order+1);
end
smoothSignal = zeros(1,q);
%-preallocation------------------------------------------------------------
X_hat_save = zeros(m,n);
B_hat_save = zeros(m,1);
e_SEVN_save = zeros(m,1);
e_SE_save = zeros(m,1);
r_SE_save = zeros(m,1);
NoiseSigma2_save = zeros(m,q);
smoothSignal_save = zeros(m,q);
%--------------------------------------------------------------------------
for i = 1 : m    
    %PKS Filter
    for j=1:q 
        [PKS_X(:,:,j), PKS_P(:,:,j)] = fcn_PKS(PKS_X(:,:,j), PKS_P(:,:,j), u, Z_mess(i,j), calA, R);
        smoothSignal(j) = uSmooth * PKS_X(:,:,j);
    end
    if i > rightWindow
        smoothRes = Z_mess(i-rightWindow,:) - smoothSignal;
        [errCov] = 0.998 * errCov + (1-0.998)*(smoothRes'*smoothRes);    
    end
    if i < rightWindow;
    % do nothing
    elseif i == rightWindow %initialization
        [X_hat, ~]  = fcn_ls(A_mess(1:i,:) , B_mess(1:i,:)); 
        P = (Z_mess(1:i,:)'*Z_mess(1:i,:)) \ eye(q);
    else   
        [X_hat, P] = fcn_RGTLS_InverseIteration(A_mess(i,:), B_mess(i), P, X_hat, errCov, lambda);
        B_hat = B_mess(i) - ((B_mess(i) - A_mess(i,:)*X_hat)/(1 + X_hat'*X_hat));
        e_SEVN = norm(X_true(i,:)' - X_hat)^2;
        e_SE = (B_mess(i) - B_hat)^2;
        r_SE = (B_true(i) - A_true(i,:) * X_hat)^2;
        % Ergebnisse speichern    
        X_hat_save(i,:) = X_hat';
        B_hat_save(i) = B_hat;
        e_SEVN_save(i) = e_SEVN;
        e_SE_save(i) = e_SE;
        r_SE_save(i) = r_SE;
        NoiseSigma2_save(i,:) = diag(errCov);
        smoothSignal_save(i-rightWindow,:) = smoothSignal;
    end
end
Result.X_hat = X_hat_save;
Result.B_hat = B_hat_save;
Result.e_SEVN = e_SEVN_save;
Result.e_SE = e_SE_save;
Result.r_SE = r_SE_save;
Result.NoiseSigma2 = NoiseSigma2_save;
Result.smoothSignal = smoothSignal_save;
%
end %of function-----------------------------------------------------------
%
function Versuchsplan = fcn_versuchsplan_erstellen (In)
m = In.m;
InputTyp = In.InputTyp;
inputTuning = In.inputTuning;
windup = In.windup;
NoiseTyp = In.NoiseTyp;
noiseTuning = In.noiseTuning;
NoiseSigma2 = In.NoiseSigma2;
X_true = In.X_true;
wiederholungen = In.wiederholungen;
%
[m_size,~] = size(m);
[windup_size,~] = size(windup);
[X_true_size,~] = size(X_true);
[NoiseSigma2_size,~] = size(NoiseSigma2);
[NoiseTyp_size,~] = size(NoiseTyp);
[noiseTuning_size,~] = size(noiseTuning);
[InputTyp_size,~] = size(InputTyp);
[inputTuning_size,~] = size(inputTuning);
%
versuchsnummer=0;
%
Versuche = m_size *...
X_true_size *...
NoiseSigma2_size *...
NoiseTyp_size * ...
InputTyp_size *...
inputTuning_size *...
windup_size *...
noiseTuning_size;
Versuchsplan = cell(Versuche,1); %initialisieren
%
for m_count           = 1:m_size          
for X_true_count      = 1:X_true_size                           
for NoiseSigma2_count = 1:NoiseSigma2_size                    
for NoiseTyp_count    = 1:NoiseTyp_size                        
for InputTyp_count    = 1:InputTyp_size                        
for inputTuning_count = 1:inputTuning_size
for windup_count      = 1:windup_size
for noiseTuning_count = 1:noiseTuning_size
    versuchsnummer=versuchsnummer+1;
    Versuchsplan{(versuchsnummer),1}.versuchsnummer = versuchsnummer;
    Versuchsplan{(versuchsnummer),1}.wiederholungen = wiederholungen;
    %                 
    Versuchsplan{(versuchsnummer),1}.m = m{m_count};
    Versuchsplan{(versuchsnummer),1}.X_true = X_true{X_true_count};
    Versuchsplan{(versuchsnummer),1}.NoiseSigma2 = NoiseSigma2{NoiseSigma2_count}; 
    Versuchsplan{(versuchsnummer),1}.noiseTuning = noiseTuning{noiseTuning_count};                    
    Versuchsplan{(versuchsnummer),1}.NoiseTyp = NoiseTyp{NoiseTyp_count};
    Versuchsplan{(versuchsnummer),1}.InputTyp = InputTyp{InputTyp_count};
    Versuchsplan{(versuchsnummer),1}.inputTuning = inputTuning{inputTuning_count};
    Versuchsplan{(versuchsnummer),1}.windup = windup{windup_count};
end
end
end                    
end
end
end
end  
end
%
end %of function-----------------------------------------------------------
%
function Out = fcn_simulationsdaten_erstellen(In)
InputTyp = In.InputTyp;
inputTuning = In.inputTuning;
windup = In.windup;
NoiseTyp = In.NoiseTyp;
noiseTuning = In.noiseTuning;
NoiseSigma2 = In.NoiseSigma2;
X_true = In.X_true;
m = In.m;
%
n = size(inputTuning,2);
t = repmat((1:m)', 1, n);
Arg = repmat(inputTuning,m,1).* t;
switch InputTyp
    case 'sinus'
        % sinus A
        Atrue = sin(2*pi*Arg);
    case 'modulierterSinus'
        % modulierter sinus A
        Atrue = sin(2*pi*Arg).*sin(2*pi*Arg/3.3);   
    case 'constant'
        % Constant input
        Atrue = repmat(inputTuning,m,1).*ones(m ,n);
    case 'sawtooth'
        % Sawtooth function
        Atrue = sawtooth(Arg);
    case 'square'
        % Square function with random duty cycle
        Atrue = square(Arg);
    case 'exp_up'
        % rising exponential function.
        Atrue = exp(Arg);
    case 'exp_down'
        % falling exponential function
        Atrue = exp(-Arg);
    otherwise
        error('Invalid InputTyp')
end
%
for i=1:n
    lengthWindup = windup(2,i) - windup(1,i);
    shiftSignal = Atrue(windup(1,i):end,i);
    Atrue(windup(1,i):windup(2,i)-1,i) = repmat(Atrue(windup(1,i),i), lengthWindup, 1);
    Atrue(windup(2,i):end, i) = shiftSignal(1:end-lengthWindup,:);
end
%
if isvector(X_true) %konstante Parameter
    Btrue = Atrue * X_true;
    X_true = repmat(X_true , 1 ,m);
elseif size(X_true,2)==3
    Btrue=zeros(m,1);
    xshiftTrue = zeros(n,m);
    for i=1:n
       xshiftTrue(i,:) = [repmat(X_true(i,1), 1, X_true(i,3)-1),... %Parameter Anfang
                          repmat(X_true(i,2), 1, m-X_true(i,3)+1)];  %Parameter Sprung bis Ende
    end
    X_true = xshiftTrue;
    %    
    for i=1:m
        Btrue(i) = Atrue(i,:) * X_true(:,i);
    end
else
    error('size xTrue falsch')   
end
%
Z_true = [Atrue , Btrue];
q=size(Z_true,2);
tq = [t, t(:,1)]; %t um Btrue spalte erweitern
%
NoiseSigma2 = repmat(NoiseSigma2,m,1);
Noise = sqrt(NoiseSigma2).* randn(m,q); %add white Gaussian noise to all inputs
%noise mode
switch NoiseTyp
    case 'constant'
        n_mode= ones(m, q);
    case 'sinus'
        sinArg = repmat(noiseTuning,m,1).* tq;
        n_mode = sin(2*pi*sinArg);
    case 'markov'
        markov = ones(m,q);
        for i=2:m
            markov(i,:) = markov(i-1,:)+ sqrt(noiseTuning).*randn(1,q);
        end
       n_mode = markov;       
    otherwise
        error('Invalid NoiseTyp')         
end
NoiseSigma2 = NoiseSigma2 .* abs(n_mode); %Modulation von NoiseSigma2 speichern
%add  noise
Z_error = Noise .* n_mode;
%Simulationsdaten speichern
Out.Repeat.A_true  = Z_true(:,1:n);
Out.Single.A_error = Z_error(:,1:n);
%
Out.Repeat.B_true  = Z_true(:,n+1:q);
Out.Single.B_error = Z_error(:,n+1:q);
%
Out.Single.NoiseSigma2 = NoiseSigma2;
Out.Repeat.X_true  = X_true';
end %of function-----------------------------------------------------------